# Generated by Django 4.0.6 on 2022-08-06 13:37

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Battle',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=100)),
                ('code', models.CharField(blank=True, max_length=16, null=True, unique=True)),
                ('state', models.CharField(choices=[('I', 'Inscription'), ('U', 'Rendu des photos'), ('V', 'Vote'), ('C', 'Terminé')], default='I', max_length=1)),
                ('photo_count', models.PositiveIntegerField(default=3)),
                ('date_creation', models.DateTimeField(auto_now_add=True)),
                ('date_upload', models.DateTimeField(blank=True, null=True)),
                ('date_vote', models.DateTimeField(blank=True, null=True)),
                ('date_closed', models.DateTimeField(blank=True, null=True)),
                ('owner', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'ordering': ['-date_creation'],
            },
        ),
        migrations.CreateModel(
            name='Team',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True)),
                ('date_creation', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Vote',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ranking', models.TextField()),
                ('date_creation', models.DateTimeField(auto_now_add=True)),
                ('battle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='votes', to='photobattle.battle')),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='votes', to='photobattle.team')),
            ],
            options={
                'ordering': ['-date_creation'],
            },
        ),
        migrations.CreateModel(
            name='Result',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rank', models.PositiveIntegerField()),
                ('grade', models.FloatField()),
                ('date_creation', models.DateTimeField(auto_now_add=True)),
                ('battle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='results', to='photobattle.battle')),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='results', to='photobattle.team')),
            ],
            options={
                'ordering': ['-battle', 'rank'],
            },
        ),
        migrations.CreateModel(
            name='Photo',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_creation', models.DateTimeField(auto_now_add=True)),
                ('url', models.URLField()),
                ('url_thumbnail', models.URLField()),
                ('grade', models.FloatField(blank=True, null=True)),
                ('battle', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='photos', to='photobattle.battle')),
                ('team', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='photos', to='photobattle.team')),
            ],
            options={
                'ordering': ['-date_creation'],
            },
        ),
        migrations.AddField(
            model_name='battle',
            name='teams',
            field=models.ManyToManyField(blank=True, related_name='battles', to='photobattle.team'),
        ),
    ]
